package com.hotwj.platform.config.systemAgreement.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.systemAgreement.domain.HotSystemAgreement;
import com.hotwj.platform.config.systemAgreement.domain.bo.HotSystemAgreementBo;
import com.hotwj.platform.config.systemAgreement.domain.vo.HotSystemAgreementVo;
import com.hotwj.platform.config.systemAgreement.mapper.HotSystemAgreementMapper;
import com.hotwj.platform.config.systemAgreement.service.IHotSystemAgreementService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 用户隐私政策Service业务层处理
 *
 * @author shihongwei
 * @date 2026-01-08
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotSystemAgreementServiceImpl implements IHotSystemAgreementService {

    private final HotSystemAgreementMapper baseMapper;

    /**
     * 查询用户隐私政策
     *
     * @param id 主键
     * @return 用户隐私政策
     */
    @Override
    public HotSystemAgreementVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询用户隐私政策列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 用户隐私政策分页列表
     */
    @Override
    public TableDataInfo<HotSystemAgreementVo> queryPageList(HotSystemAgreementBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotSystemAgreement> lqw = buildQueryWrapper(bo);
        Page<HotSystemAgreementVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的用户隐私政策列表
     *
     * @param bo 查询条件
     * @return 用户隐私政策列表
     */
    @Override
    public List<HotSystemAgreementVo> queryList(HotSystemAgreementBo bo) {
        LambdaQueryWrapper<HotSystemAgreement> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotSystemAgreement> buildQueryWrapper(HotSystemAgreementBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotSystemAgreement> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotSystemAgreement::getId);
        lqw.like(StringUtils.isNotBlank(bo.getAgreementName()), HotSystemAgreement::getAgreementName, bo.getAgreementName());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), HotSystemAgreement::getContent, bo.getContent());
        lqw.eq(bo.getIsDeleted() != null, HotSystemAgreement::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增用户隐私政策
     *
     * @param bo 用户隐私政策
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotSystemAgreementBo bo) {
        HotSystemAgreement add = MapstructUtils.convert(bo, HotSystemAgreement.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改用户隐私政策
     *
     * @param bo 用户隐私政策
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotSystemAgreementBo bo) {
        HotSystemAgreement update = MapstructUtils.convert(bo, HotSystemAgreement.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotSystemAgreement entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除用户隐私政策信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
